sub commandrun
{
my $comm=$_[0];
my $i="";
my @out=();
my $commrpl;


if($comm=~/COMMUNITY/)
    {
    $commrpl=loadpwd($host,"community");
    $comm=~s/COMMUNITY/$commrpl/;
    }


deb("\nexecuting command <$comm>");
$out[0]=`$comm 2>&1`;

$flag=$?; uncoment this line for x86, and comment out next
#$flag=$?/256;
deb("exec return '$out[0]' and exit with status $flag");
if($flag>2){tostd("$out[0] ($flag), exiting"); exit 3;}
$out[1]=$flag;

return @out;
}

sub checkmax
{
my ($cur,$max,$lim)=($_[0],$_[1],$_[2]);
my $sp;
if($cur=~/^\d+/){
		$sp=$max-$lim*$max;
		if($sp <$cur){return 1;}
		}
return 0;
}

sub getofs
{
my ($ofs,$now)=($_[0],$_[1]);
my $tmp;
if(length($ofs)<1)
    {
    return $now,0;
    }
elsif($now<$ofs)
    {
    $tmp=4294967295-$ofs+$now;
    return $now,$tmp;
    }
return $now,$now-$ofs;
}

sub openofsfile
{
my ($host,$intf)=($_[0],$_[1]);
my $WPATH=$OFFSETS . "/$host/";
my $LL;
my $tmp;
$intf=strrpl($intf);
if(!(-d $WPATH) )
    {
    tolog("Creating directory $WPATH");
    if(!mkdir($WPATH))
	{
	tostd("Unable to creating directory $WPATH, dying");
	exit 3;
	}
    
    }
my $WFILE=$WPATH . $intf . ".ofs";
if(!(-e $WFILE))
    {
    tolog("No offset file $WFILE, creating");
    open(LL,">$WFILE");    
    }
else
    {
    open(LL,$WFILE);
    $tmp=<LL>;
    close(LL);
    open(LL,">$WFILE");
    }
return $tmp,$LL;
}

sub stdec
{
my %ifOperStatus =      ('0','unknown',
		    '1','up',
                     '2','down',
                      '3','testing',
                   '4','unknown',
                    '5','dormant',
                 '6','notPresent');
return $ifOperStatus{$_[0]};
}

sub ifsnmpinfo
{
my @a=();
my ($host,$intf)=($_[0],$_[1]);

if(!open(CFG_,"$IFINDEX/$host.idx"))
    {
    print "Cannot open index file <$IFINDEX/$host.idx";
    exit 3;
    }
while($l=<CFG_>)
{
(@a)=split(';',$l);
if($a[1]=~/$intf/i){return $a[0],$a[2];}
}
tostd("Interface <$intf> not found in db <$IFINDEX/$host.idx>");
exit 3;
}

sub rshexec
{
my @out=();
@out=`$RSH $_[0] -l $_[1] $_[2] 2>&1`;
return $?,@out;
}
sub chkifhst
{
if(!($_[0]=~/\d+\.\d+\.\d+\.\d+/))
    {
    tostd("invalid host or host not set");
    return 1;
    }
if(!defined($_[1])){print "host or interface not set";return 1;}
return 0;
}

sub strrpl
{
$_[0]=~s/\s/_s_/g;
$_[0]=~s/\//_b_/g;
$_[0]=~s/'/_t_/g;
$_[0]=~s/:/_d_/g;
return $_[0];
}

sub loadpwd
{
my $tmp;
my @cfg;
my $flag;
my $param=$_[1];
my $host=$_[0];
open(A,"$NAGETC/sat.pwd.cfg") || die ("cannot open config file");
deb("========deginning read cfg file========");
$/="}\n";
while(<A>)
{
deb("parsing segment <$_>");
$flag=0;$tmp="";
foreach (split /\n/)
    {
    if(/^hostip\s+(.*)/)
	{
	if($1 eq $host or $1 eq "default"){$tmp=$1;$flag=1;}
	}
    if(/^$param\s+(.*)/ and $flag)
	{
	deb("setting $param <$1> for $tmp");
	$cfg{$tmp}=$1;
	last;
	}
    }    
deb("<==parsing finished");
    }
deb("========config file parsed========");
$/="\n";

if(defined($cfg{$host})) 
    {
    deb("selected $param <$cfg{$host}>");
    return $cfg{$host};
    }
elsif(defined($cfg{"default"}))
    {
    deb("default $param selected <$cfg{'default'}>");
    return $cfg{"default"};
    }

tostd("$param not found. exiting.");
exit 3;
}

sub tolog
{
#my $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst;
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);
$isdst=  eval(1900+$year) . "/" . eval($mon+1) . "/$mday $hour:$min:$sec -- [$MODULE]: $_[0]\n";
if(!$DEBUG){print LOG $isdst;} else {print $isdst;}
}
sub tostd
{
print "$_[0]\n";
}
sub toerr
{
print STDERR "$_[0]\n";
}

sub deb
{
if($DEBUG) {print STDERR "*$_[0]*\n";}
}
1;